<template>
  <section class="section">
    <div class="container" v-if="!$apollo.loading">
      <h1 class="title">{{ repo.name }}</h1>
      <h3 class="subtitle">{{ repo.description }}</h3>
      <hr>
      <div class="container column is-4" v-if="dependencies.length > 0">
        <h4 class="subtitle">Dependencies</h4>
        <span v-for="(dep, index) in dependencies" :key="index">
          <code><span v-html="checkDep(dep)" /></code><br>
        </span>
        <br>
        <p>Total: {{ total }} a month</p><br>
        <br>
        <button @click="addRepo" class="button is-warning">Add</button>
      </div>
      <div class="container" v-else>
        <p><strong>No Dependencies.</strong></p><br>
        <router-link class="button is-primary" :to="{ name: 'repositories' }">Back</router-link>
      </div>
    </div>
  </section>
</template>

<script>
import REPOSITORY_PACKAGE_QUERY from '@/graphql/Github/Repository.gql'
import USER_QUERY from '@/graphql/User/User.gql'
import ADD_REPO from '@/graphql/Github/addRepo.gql'
export default {
  data: () => ({
    repo: {},
    dependencies: [],
    user: {}
  }),
  computed: {
    total () {
      const newDeps = this.dependencies.filter(dep => !this.contributing.includes(dep))
      return new Intl.NumberFormat(this.user.currency.locale, { style: 'currency', currency: this.user.currency.abbreviation }).format(newDeps.length * this.user.amount)
    },
    contributing () {
      return this.user.contributing.map(dep => dep.name)
    }
  },
  apollo: {
    user: {
      query: USER_QUERY,
      fetchPolicy: 'cache-and-network'
    }
  },
  created () {
    this.$apollo.query({
      client: 'github',
      query: REPOSITORY_PACKAGE_QUERY,
      variables: {
        name: this.$route.params.name
      }
    }).then(({ data }) => {
      this.repo = data.viewer.repository
      const dependencies = JSON.parse(data.viewer.repository.object.text).dependencies
      if (dependencies) this.dependencies = Object.keys(dependencies)
    })
  },
  methods: {
    checkDep (name) {
      if (this.contributing.includes(name)) return `<del>${name}</del>`
      else return name
    },
    addRepo () {
      this.$apollo.mutate({
        mutation: ADD_REPO,
        variables: {
          name: this.repo.name,
          description: this.repo.description || '',
          dependencies: this.dependencies
        }
      }).then(({ data }) => {
        this.$toast.open('Add Repository and Dependencies!')
        this.$router.push('/repositories')
      }).catch(err => console.error(err))
    }
  }
}
</script>
